Index: __init__.py
===================================================================
--- __init__.py	(revision 21)
+++ __init__.py	(revision 130)
@@ -1,4 +1,4 @@
 import documentViewer
-
+import MpdlXmlTextServer
 
 def initialize(context):
@@ -19,3 +19,11 @@
           )
         )
+
+    context.registerClass(
+        MpdlXmlTextServer.MpdlXmlTextServer,
+        constructors = (
+          MpdlXmlTextServer.manage_addMpdlXmlTextServerForm,
+          MpdlXmlTextServer.manage_addMpdlXmlTextServer
+          )
+        )
     
Index: documentViewer.py
===================================================================
--- documentViewer.py	(revision 128)
+++ documentViewer.py	(revision 130)
@@ -3,29 +3,18 @@
 from Products.PageTemplates.ZopePageTemplate import ZopePageTemplate
 from Products.PageTemplates.PageTemplateFile import PageTemplateFile 
-from Products.PythonScripts.standard import url_quote
 from AccessControl import ClassSecurityInfo
 from AccessControl import getSecurityManager
 from Globals import package_home
 
-from Ft.Xml.Domlette import NonvalidatingReader
+from Ft.Xml import EMPTY_NAMESPACE, Parse
 from Ft.Xml.Domlette import PrettyPrint, Print
-from Ft.Xml import EMPTY_NAMESPACE, Parse
-
-from xml.dom.minidom import parse, parseString
-
-
-
-import Ft.Xml.XPath
-import cStringIO
-import xmlrpclib
 import os.path
 import sys
-import cgi
 import urllib
+import urllib2
 import logging
 import math
-
 import urlparse 
-from types import *
+import cStringIO
 
 def logger(txt,method,txt2):
@@ -66,12 +55,47 @@
         
 
-import socket
-
-def urlopen(url,timeout=2):
-        """urlopen mit timeout"""
-        socket.setdefaulttimeout(timeout)
-        ret=urllib.urlopen(url)
-        socket.setdefaulttimeout(5)
-        return ret
+def getHttpData(url, data=None, num_tries=3, timeout=10):
+    """returns result from url+data HTTP request"""
+    # we do GET (by appending data to url)
+    if isinstance(data, str) or isinstance(data, unicode):
+        # if data is string then append
+        url = "%s?%s"%(url,data)
+    elif isinstance(data, dict) or isinstance(data, list) or isinstance(data, tuple):
+        # urlencode
+        url = "%s?%s"%(url,urllib.urlencode(data))
+    
+    response = None
+    errmsg = None
+    for cnt in range(num_tries):
+        try:
+            logging.debug("getHttpData(#%s %ss) url=%s"%(cnt+1,timeout,url))
+            if sys.version_info < (2, 6):
+                # set timeout on socket -- ugly :-(
+                import socket
+                socket.setdefaulttimeout(float(timeout))
+                response = urllib2.urlopen(url)
+            else:
+                response = urllib2.urlopen(url,timeout=float(timeout))
+            # check result?
+            break
+        except urllib2.HTTPError, e:
+            logging.error("getHttpData: HTTP error(%s): %s"%(e.code,e))
+            errmsg = str(e)
+            # stop trying
+            break
+        except urllib2.URLError, e:
+            logging.error("getHttpData: URLLIB error(%s): %s"%(e.reason,e))
+            errmsg = str(e)
+            # stop trying
+            #break
+
+    if response is not None:
+        data = response.read()
+        response.close()
+        return data
+    
+    raise IOError("ERROR fetching HTTP data from %s: %s"%(url,errmsg))
+    #return None
+
 
 
@@ -81,6 +105,4 @@
 class documentViewer(Folder):
     """document viewer"""
-    #textViewerUrl="http://127.0.0.1:8080/HFQP/testXSLT/getPage?"
-    
     meta_type="Document viewer"
     
@@ -102,5 +124,6 @@
     docuviewer_css = PageTemplateFile('css/docuviewer.css', globals())
     info_xml = PageTemplateFile('zpt/info_xml', globals())
-
+    
+    
     thumbs_main_rss = PageTemplateFile('zpt/thumbs_main_rss', globals())
     security.declareProtected('View management screens','changeDocumentViewerForm')    
@@ -122,10 +145,10 @@
         self._setObject('template',templateFolder) # old style
         try:
-            from Products.XMLRpcTools.XMLRpcTools import XMLRpcServerProxy
-            xmlRpcClient = XMLRpcServerProxy(id='fulltextclient', serverUrl=textServerName, use_xmlrpc=False)
+            import MpdlXmlTextServer
+            textServer = MpdlXmlTextServer(id='fulltextclient')
             #templateFolder['fulltextclient'] = xmlRpcClient
-            templateFolder._setObject('fulltextclient',xmlRpcClient)
+            templateFolder._setObject('fulltextclient',textServer)
         except Exception, e:
-            logging.error("Unable to create XMLRpcTools for fulltextclient: "+str(e))
+            logging.error("Unable to create MpdlXmlTextServer for fulltextclient: "+str(e))
         try:
             from Products.zogiLib.zogiLib import zogiLib
@@ -136,5 +159,39 @@
             logging.error("Unable to create zogiLib for zogilib: "+str(e))
         
-
+        
+    # proxy text server methods to fulltextclient
+    def getTextPage(self, **args):
+        """get page"""
+        return self.template.fulltextclient.getTextPage(**args)
+
+    def getQuery(self, **args):
+        """get query"""
+        return self.template.fulltextclient.getQuery(**args)
+
+    def getSearch(self, **args):
+        """get search"""
+        return self.template.fulltextclient.getSearch(**args)
+
+    def getNumPages(self, **args):
+        """get numpages"""
+        return self.template.fulltextclient.getNumPages(**args)
+
+    def getTranslate(self, **args):
+        """get translate"""
+        return self.template.fulltextclient.getTranslate(**args)
+
+    def getLemma(self, **args):
+        """get lemma"""
+        return self.template.fulltextclient.getLemma(**args)
+
+    def getToc(self, **args):
+        """get toc"""
+        return self.template.fulltextclient.getToc(**args)
+
+    def getTocPage(self, **args):
+        """get tocpage"""
+        return self.template.fulltextclient.getTocPage(**args)
+
+    
     security.declareProtected('View','thumbs_rss')
     def thumbs_rss(self,mode,url,viewMode="auto",start=None,pn=1):
@@ -161,5 +218,5 @@
         
         if viewMode=="auto": # automodus gewaehlt
-            if docinfo.get("textURL",'') and self.textViewerUrl: #texturl gesetzt und textViewer konfiguriert
+            if docinfo.has_key("textURL") or docinfo.has_key('textURLPath'): #texturl gesetzt und textViewer konfiguriert
                 viewMode="text"
             else:
@@ -197,5 +254,5 @@
             
         if viewMode=="auto": # automodus gewaehlt
-            if docinfo.get("textURL",''): #texturl gesetzt und textViewer konfiguriert
+            if docinfo.has_key("textURL") or docinfo.has_key('textURLPath'): #texturl gesetzt und textViewer konfiguriert
                 viewMode="text_dict"
             else:
@@ -265,5 +322,5 @@
                 
         # quote values and assemble into query string
-        logging.info("XYXXXXX: %s"%repr(params.items()))
+        logging.debug("XYXXXXX: %s"%repr(params.items()))
         ps = "&amp;".join(["%s=%s"%(k,urllib.quote(v)) for (k, v) in params.items()])
         url=self.REQUEST['URL1']+"?"+ps
@@ -284,7 +341,7 @@
         """returns if access to the resource is granted"""
         access = docinfo.get('accessType', None)
-        logger("documentViewer (accessOK)", logging.INFO, "access type %s"%access)
+        logging.debug("documentViewer (accessOK) access type %s"%access)
         if access is not None and access == 'free':
-            logger("documentViewer (accessOK)", logging.INFO, "access is free")
+            logging.debug("documentViewer (accessOK) access is free")
             return True
         elif access is None or access in self.authgroups:
@@ -297,5 +354,5 @@
                 return False
         
-        logger("documentViewer (accessOK)", logging.INFO, "unknown access type %s"%access)
+        logging.debug("documentViewer (accessOK) unknown access type %s"%access)
         return False
     
@@ -303,5 +360,4 @@
     def getDirinfoFromDigilib(self,path,docinfo=None,cut=0):
         """gibt param von dlInfo aus"""
-        num_retries = 3
         if docinfo is None:
             docinfo = {}
@@ -313,19 +369,13 @@
         infoUrl=self.digilibBaseUrl+"/dirInfo-xml.jsp?mo=dir&fn="+path
     
-        logger("documentViewer (getparamfromdigilib)", logging.INFO, "dirInfo from %s"%(infoUrl))
-        
-        for cnt in range(num_retries):
-            try:
-                # dom = NonvalidatingReader.parseUri(imageUrl)
-                txt=urllib.urlopen(infoUrl).read()
-                dom = Parse(txt)
-                break
-            except:
-                logger("documentViewer (getdirinfofromdigilib)", logging.ERROR, "error reading %s (try %d)"%(infoUrl,cnt))
-        else:
+        logging.debug("documentViewer (getparamfromdigilib) dirInfo from %s"%(infoUrl))
+        
+        txt = getHttpData(infoUrl)
+        if txt is None:
             raise IOError("Unable to get dir-info from %s"%(infoUrl))
-        
+
+        dom = Parse(txt)
         sizes=dom.xpath("//dir/size")
-        logger("documentViewer (getparamfromdigilib)", logging.INFO, "dirInfo:size"%sizes)
+        logging.debug("documentViewer (getparamfromdigilib) dirInfo:size"%sizes)
         
         if sizes:
@@ -341,5 +391,4 @@
     def getIndexMeta(self, url):
         """returns dom of index.meta document at url"""
-        num_retries = 3
         dom = None
         metaUrl = None
@@ -353,23 +402,15 @@
             if not metaUrl.endswith("index.meta"):
                 metaUrl += "/index.meta"
-        logging.debug("METAURL: %s"%metaUrl)
-        for cnt in range(num_retries):
-            try:
-                # patch dirk encoding fehler treten dann nicht mehr auf
-                # dom = NonvalidatingReader.parseUri(metaUrl)
-                txt=urllib.urlopen(metaUrl).read()
-                dom = Parse(txt)
-                break
-            except:
-                logger("ERROR documentViewer (getIndexMeta)", logging.INFO,"%s (%s)"%sys.exc_info()[0:2])
                 
-        if dom is None:
+        logging.debug("(getIndexMeta): METAURL: %s"%metaUrl)
+        txt=getHttpData(metaUrl)
+        if txt is None:
             raise IOError("Unable to read index meta from %s"%(url))
-                 
+        
+        dom = Parse(txt)
         return dom
     
     def getPresentationInfoXML(self, url):
         """returns dom of info.xml document at url"""
-        num_retries = 3
         dom = None
         metaUrl = None
@@ -382,17 +423,9 @@
             metaUrl=server+url.replace("/mpiwg/online","")
         
-        for cnt in range(num_retries):
-            try:
-                # patch dirk encoding fehler treten dann nicht mehr auf
-                # dom = NonvalidatingReader.parseUri(metaUrl)
-                txt=urllib.urlopen(metaUrl).read()
-                dom = Parse(txt)
-                break
-            except:
-                logger("ERROR documentViewer (getPresentationInfoXML)", logging.INFO,"%s (%s)"%sys.exc_info()[0:2])
-                
-        if dom is None:
+        txt=getHttpData(metaUrl)
+        if txt is None:
             raise IOError("Unable to read infoXMLfrom %s"%(url))
-                 
+            
+        dom = Parse(txt)
         return dom
                         
@@ -400,5 +433,5 @@
     def getAuthinfoFromIndexMeta(self,path,docinfo=None,dom=None,cut=0):
         """gets authorization info from the index.meta file at path or given by dom"""
-        logger("documentViewer (getauthinfofromindexmeta)", logging.INFO,"path: %s"%(path))
+        logging.debug("documentViewer (getauthinfofromindexmeta) path: %s"%(path))
         
         access = None
@@ -476,5 +509,5 @@
     def getDocinfoFromTextTool(self, url, dom=None, docinfo=None):
         """parse texttool tag in index meta"""
-        logger("documentViewer (getdocinfofromtexttool)", logging.INFO, "url: %s" % (url))
+        logging.debug("documentViewer (getdocinfofromtexttool) url: %s" % (url))
         if docinfo is None:
            docinfo = {}
@@ -491,5 +524,5 @@
             archiveName = getTextFromNode(archiveNames[0])
         else:
-            logger("documentViewer (getdocinfofromtexttool)", logging.WARNING, "resource/name missing in: %s" % (url))
+            logging.warning("documentViewer (getdocinfofromtexttool) resource/name missing in: %s" % (url))
         
         archivePaths = dom.xpath("//resource/archive-path")
@@ -503,5 +536,5 @@
         else:
             # try to get archive-path from url
-            logger("documentViewer (getdocinfofromtexttool)", logging.WARNING, "resource/archive-path missing in: %s" % (url))
+            logging.warning("documentViewer (getdocinfofromtexttool) resource/archive-path missing in: %s" % (url))
             if (not url.startswith('http')):
                 archivePath = url.replace('index.meta', '')
@@ -536,5 +569,6 @@
             viewerUrl = getTextFromNode(viewerUrls[0])
             docinfo['viewerURL'] = viewerUrl
-                   
+        
+        # old style text URL
         textUrls = dom.xpath("//texttool/text")
         if textUrls and (len(textUrls) > 0):
@@ -548,4 +582,5 @@
             docinfo['textURL'] = textUrl
     
+        # new style text-url-path
         textUrls = dom.xpath("//texttool/text-url-path")
         if textUrls and (len(textUrls) > 0):
@@ -595,5 +630,5 @@
     def getDocinfoFromImagePath(self,path,docinfo=None,cut=0):
         """path ist the path to the images it assumes that the index.meta file is one level higher."""
-        logger("documentViewer (getdocinfofromimagepath)", logging.INFO,"path: %s"%(path))
+        logging.debug("documentViewer (getdocinfofromimagepath) path: %s"%(path))
         if docinfo is None:
             docinfo = {}
@@ -605,5 +640,5 @@
         for x in range(cut):       
                 path=getParentDir(path)
-        logging.error("PATH:"+path)
+        logging.debug("documentViewer (getdocinfofromimagepath) PATH:"+path)
         imageUrl=self.digilibBaseUrl+"/servlet/Scaler?fn="+path
         docinfo['imageURL'] = imageUrl
@@ -617,5 +652,5 @@
     def getDocinfo(self, mode, url):
         """returns docinfo depending on mode"""
-        logger("documentViewer (getdocinfo)", logging.INFO,"mode: %s, url: %s"%(mode,url))
+        logging.debug("documentViewer (getdocinfo) mode: %s, url: %s"%(mode,url))
         # look for cached docinfo in session
         if self.REQUEST.SESSION.has_key('docinfo'):
@@ -623,5 +658,5 @@
             # check if its still current
             if docinfo is not None and docinfo.get('mode') == mode and docinfo.get('url') == url:
-                logger("documentViewer (getdocinfo)", logging.INFO,"docinfo in session: %s"%docinfo)
+                logging.debug("documentViewer (getdocinfo) docinfo in session: %s"%docinfo)
                 return docinfo
         # new docinfo
@@ -634,8 +669,8 @@
             docinfo = self.getDocinfoFromImagePath(url, docinfo=docinfo,cut=1)
         else:
-            logger("documentViewer (getdocinfo)", logging.ERROR,"unknown mode!")
+            logging.error("documentViewer (getdocinfo) unknown mode: %s!"%mode)
             raise ValueError("Unknown mode %s! Has to be one of 'texttool','imagepath','filepath'."%(mode))
                         
-        logger("documentViewer (getdocinfo)", logging.INFO,"docinfo: %s"%docinfo)
+        logging.debug("documentViewer (getdocinfo) docinfo: %s"%docinfo)
         self.REQUEST.SESSION['docinfo'] = docinfo
         return docinfo
@@ -687,249 +722,4 @@
         pageinfo['sn'] =self.REQUEST.get('sn','')
         return pageinfo
-                
-    def getSearch(self, pn=1, pageinfo=None,  docinfo=None, query=None, queryType=None, lemma=None):
-        """get search list"""
-        docpath = docinfo['textURLPath'] 
-        url = docinfo['url']
-        logging.debug("documentViewer (gettoc) docpath: %s"%(docpath))
-        logging.debug("documentViewer (gettoc) url: %s"%(url))
-        pagesize = pageinfo['queryPageSize']
-        pn = pageinfo['searchPN']
-        sn = pageinfo['sn']
-        highlightQuery = pageinfo['highlightQuery']
-        query =pageinfo['query']
-        queryType =pageinfo['queryType']
-        viewMode=  pageinfo['viewMode']
-        tocMode = pageinfo['tocMode']
-        tocPN = pageinfo['tocPN']
-        selfurl = self.absolute_url()
-        page=self.template.fulltextclient.eval("/mpdl/interface/doc-query.xql","document=%s&mode=%s&queryType=%s&query=%s&queryResultPageSize=%s&queryResultPN=%s&sn=%s&viewMode=%s&highlightQuery=%s"%(docpath, 'text', queryType, query, pagesize, pn, sn, viewMode,highlightQuery) ,outputUnicode=False)                
-        pagexml = page.replace('?document=%s'%str(docpath),'?url=%s'%url)
-        pagedom = Parse(pagexml)
-        if (queryType=="fulltext")or(queryType=="xpath")or(queryType=="xquery")or(queryType=="fulltextMorphLemma"):   
-            pagedivs = pagedom.xpath("//div[@class='queryResultPage']")
-            if len(pagedivs)>0:
-                pagenode=pagedivs[0]
-                links=pagenode.xpath("//a")
-                for l in links:
-                    hrefNode = l.getAttributeNodeNS(None, u"href")
-                    if hrefNode:
-                        href = hrefNode.nodeValue
-                        if href.startswith('page-fragment.xql'):
-                            selfurl = self.absolute_url()            
-                            pagexml=href.replace('mode=text','mode=texttool&viewMode=%s&queryType=%s&query=%s&queryResultPageSize=%s&queryResultPN=%s&tocMode=%s&searchPN=%s&tocPN=%s'%(viewMode,queryType,query,pagesize,pn,tocMode,pn,tocPN))
-                            hrefNode.nodeValue = pagexml.replace('page-fragment.xql','%s'%selfurl)                                           
-                return serializeNode(pagenode)        
-        if (queryType=="fulltextMorph"):
-            pagedivs = pagedom.xpath("//div[@class='queryResult']")
-            if len(pagedivs)>0:
-                pagenode=pagedivs[0]
-                links=pagenode.xpath("//a")
-                for l in links:
-                    hrefNode = l.getAttributeNodeNS(None, u"href")
-                    if hrefNode:
-                        href = hrefNode.nodeValue
-                        if href.startswith('page-fragment.xql'):
-                            selfurl = self.absolute_url()       
-                            pagexml=href.replace('mode=text','mode=texttool&viewMode=%s&queryType=%s&query=%s&queryResultPageSize=%s&queryResultPN=%s&tocMode=%s&searchPN=%s&tocPN=%s'%(viewMode,queryType,query,pagesize,pn,tocMode,pn,tocPN))
-                            hrefNode.nodeValue = pagexml.replace('page-fragment.xql','%s'%selfurl)  
-                        if href.startswith('../lt/lemma.xql'):
-                            hrefNode.nodeValue = href.replace('../lt/lemma.xql','%s/template/head_main_lemma_New'%(selfurl))        
-                            l.setAttributeNS(None, 'target', '_blank')
-                            l.setAttributeNS(None, 'onClick',"popupWin = window.open(this.href, 'contacts', 'location,width=500,height=600,top=180, left=400, scrollbars=1'); return false;")
-                            l.setAttributeNS(None, 'onDblclick', 'popupWin.focus();')  
-                pagedivs = pagedom.xpath("//div[@class='queryResultMorphExpansion']")                
-                return serializeNode(pagenode)        
-        if (queryType=="ftIndex")or(queryType=="ftIndexMorph"):
-            pagedivs= pagedom.xpath("//div[@class='queryResultPage']")
-            if len(pagedivs)>0:
-                pagenode=pagedivs[0]
-                links=pagenode.xpath("//a")
-                for l in links:
-                    hrefNode = l.getAttributeNodeNS(None, u"href")
-                    if hrefNode:
-                        href = hrefNode.nodeValue
-                        hrefNode.nodeValue=href.replace('mode=text','mode=texttool&viewMode=%s&tocMode=%s&tocPN=%s&pn=%s'%(viewMode,tocMode,tocPN,pn))             
-                        if href.startswith('../lt/lex.xql'):
-                            hrefNode.nodeValue = href.replace('../lt/lex.xql','%s/template/head_main_voc'%selfurl)         
-                            l.setAttributeNS(None, 'target', '_blank')
-                            l.setAttributeNS(None, 'onClick',"popupWin = window.open(this.href, 'contacts', 'location,width=500,height=600,top=180, left=400, scrollbars=1'); return false;")
-                            l.setAttributeNS(None, 'onDblclick', 'popupWin.focus();')
-                        if href.startswith('../lt/lemma.xql'):
-                            hrefNode.nodeValue = href.replace('../lt/lemma.xql','%s/template/head_main_lemma'%selfurl)        
-                            l.setAttributeNS(None, 'target', '_blank')
-                            l.setAttributeNS(None, 'onClick',"popupWin = window.open(this.href, 'contacts', 'location,width=500,height=600,top=180, left=400, scrollbars=1'); return false;")
-                            l.setAttributeNS(None, 'onDblclick', 'popupWin.focus();')
-                return serializeNode(pagenode)      
-        return "no text here"   
-                       
-    def getNumPages(self,docinfo=None):
-        """get list of pages from fulltext and put in docinfo"""
-        xquery = '//pb'
-        text = self.template.fulltextclient.eval("/mpdl/interface/xquery.xql", "document=%s&xquery=%s"%(docinfo['textURLPath'],xquery))
-        # TODO: better processing of the page list. do we need the info somewhere else also?
-        docinfo['numPages'] = text.count("<pb ")
-        return docinfo
-       
-    def getTextPage(self, mode="text", pn=1, docinfo=None, pageinfo=None, highlightQuery=None,sn=None, viewMode=None, tocMode=None, tocPN=None):
-        """returns single page from fulltext"""
-        docpath = docinfo['textURLPath']
-        path = docinfo['textURLPath']
-        url = docinfo['url']
-        viewMode= pageinfo['viewMode']
-        tocMode = pageinfo['tocMode']
-        tocPN = pageinfo['tocPN']
-        selfurl = self.absolute_url()   
-        if mode == "text_dict":
-            textmode = "textPollux"
-        else:
-            textmode = mode
-        
-        textParam = "document=%s&mode=%s&pn=%s"%(docpath,textmode,pn)
-        if highlightQuery is not None:
-            textParam +="&highlightQuery=%s&sn=%s"%(highlightQuery,sn)           
-        pagexml=self.template.fulltextclient.eval("/mpdl/interface/page-fragment.xql", textParam, outputUnicode=False)
-        pagedom = Parse(pagexml)
-        # plain text mode
-        if mode == "text":
-            # first div contains text
-            pagedivs = pagedom.xpath("/div")
-            if len(pagedivs) > 0:      
-                pagenode = pagedivs[0]
-                links = pagenode.xpath("//a")
-                for l in links:
-                    hrefNode = l.getAttributeNodeNS(None, u"href")
-                    if hrefNode:
-                        href= hrefNode.nodeValue
-                        if href.startswith('#note-'):
-                            hrefNode.nodeValue = href.replace('#note-',"?url=%s&viewMode=%s&tocMode=%s&tocPN=%s&pn=%s#note-"%(url,viewMode,tocMode,tocPN,pn))
-                return serializeNode(pagenode)
-        if mode == "xml":
-              # first div contains text
-              pagedivs = pagedom.xpath("/div")
-              if len(pagedivs) > 0:
-                  pagenode = pagedivs[0]
-                  return serializeNode(pagenode)
-        if mode == "pureXml":
-              # first div contains text
-              pagedivs = pagedom.xpath("/div")
-              if len(pagedivs) > 0:
-                  pagenode = pagedivs[0]
-                  return serializeNode(pagenode)      
-        # text-with-links mode
-        if mode == "text_dict":
-            # first div contains text
-            pagedivs = pagedom.xpath("/div")
-            if len(pagedivs) > 0:
-                pagenode = pagedivs[0]
-                # check all a-tags
-                links = pagenode.xpath("//a")
-                for l in links:
-                    hrefNode = l.getAttributeNodeNS(None, u"href")
-                    if hrefNode:
-                        # is link with href
-                        href = hrefNode.nodeValue
-                        if href.startswith('lt/lex.xql'):
-                            # is pollux link
-                            selfurl = self.absolute_url()
-                            # change href
-                            hrefNode.nodeValue = href.replace('lt/lex.xql','%s/template/head_main_voc'%selfurl)
-                            # add target
-                            l.setAttributeNS(None, 'target', '_blank')
-                            l.setAttributeNS(None, 'onClick',"popupWin = window.open(this.href, 'contacts', 'location,width=500,height=600,top=180, left=700, scrollbars=1'); return false;")
-                            l.setAttributeNS(None, 'onDblclick', 'popupWin.focus();')      
-                        if href.startswith('lt/lemma.xql'):    
-                            selfurl = self.absolute_url()
-                            hrefNode.nodeValue = href.replace('lt/lemma.xql','%s/template/head_main_lemma'%selfurl)
-                            l.setAttributeNS(None, 'target', '_blank')
-                            l.setAttributeNS(None, 'onClick',"popupWin = window.open(this.href, 'contacts', 'location,width=500,height=600,top=180, left=700, scrollbars=1'); return false;")
-                            l.setAttributeNS(None, 'onDblclick', 'popupWin.focus();')   
-                        if href.startswith('#note-'):
-                            hrefNode.nodeValue = href.replace('#note-',"?url=%s&viewMode=%s&tocMode=%s&tocPN=%s&pn=%s#note-"%(url,viewMode,tocMode,tocPN,pn))    
-                return serializeNode(pagenode)
-        return "no text here"
-
-    def getTranslate(self, query=None, language=None):
-        """translate into another languages"""
-        pagexml=self.template.fulltextclient.eval("/mpdl/interface/lt/lex.xql","document=&language="+str(language)+"&query="+url_quote(str(query)))
-        return pagexml
-    
-    def getLemma(self, lemma=None, language=None):
-        """simular words lemma """
-        pagexml=self.template.fulltextclient.eval("/mpdl/interface/lt/lemma.xql","document=&language="+str(language)+"&lemma="+url_quote(str(lemma)))
-        return pagexml
-    
-    def getLemmaNew(self, query=None, language=None):
-        """simular words lemma """
-        pagexml=self.template.fulltextclient.eval("/mpdl/interface/lt/lemma.xql","document=&language="+str(language)+"&lemma="+url_quote(str(query)))
-        return pagexml
-
-    def getQuery (self,  docinfo=None, pageinfo=None, query=None, queryType=None, pn=1):
-         """number of"""
-         docpath = docinfo['textURLPath'] 
-         pagesize = pageinfo['queryPageSize']
-         pn = pageinfo['searchPN']
-         query =pageinfo['query']
-         queryType =pageinfo['queryType']
-         tocSearch = 0
-         tocDiv = None
-         pagexml=self.template.fulltextclient.eval("/mpdl/interface/doc-query.xql","document=%s&mode=%s&queryType=%s&query=%s&queryResultPageSize=%s&queryResultPN=%s"%(docpath, 'text', queryType, query, pagesize, pn) ,outputUnicode=False)
-         pagedom = Parse(pagexml)
-         numdivs = pagedom.xpath("//div[@class='queryResultHits']")
-         tocSearch = int(getTextFromNode(numdivs[0]))
-         tc=int((tocSearch/10)+1)
-         logging.debug("documentViewer (gettoc) tc: %s"%(tc))
-         return tc
-
-    def getToc(self, mode="text", docinfo=None):
-        """loads table of contents and stores in docinfo"""
-        logging.debug("documentViewer (gettoc) mode: %s"%(mode))
-        if mode == "none":
-            return docinfo        
-        if 'tocSize_%s'%mode in docinfo:
-            # cached toc
-            return docinfo
-        
-        docpath = docinfo['textURLPath']
-        # we need to set a result set size
-        pagesize = 1000
-        pn = 1
-        if mode == "text":
-            queryType = "toc"
-        else:
-            queryType = mode
-        # number of entries in toc
-        tocSize = 0
-        tocDiv = None
-        pagexml=self.template.fulltextclient.eval("/mpdl/interface/doc-query.xql", "document=%s&queryType=%s&queryResultPageSize=%s&queryResultPN=%s"%(docpath,queryType,pagesize,pn), outputUnicode=False)
-        # post-processing downloaded xml
-        pagedom = Parse(pagexml)
-        # get number of entries
-        numdivs = pagedom.xpath("//div[@class='queryResultHits']")
-        if len(numdivs) > 0:
-            tocSize = int(getTextFromNode(numdivs[0]))
-        docinfo['tocSize_%s'%mode] = tocSize
-        return docinfo
-    
-def getTocPage(self, mode="text", pn=1, pageinfo=None, docinfo=None):
-        """returns single page from the table of contents"""
-        # TODO: this should use the cached TOC
-        if mode == "text":
-            queryType = "toc"
-        else:
-            queryType = mode
-        docpath = docinfo['textURLPath']
-        path = docinfo['textURLPath']       
-        pagesize = pageinfo['tocPageSize']
-        pn = pageinfo['tocPN']
-        url = docinfo['url']
-        selfurl = self.absolute_url()  
-        viewMode=  pageinfo['viewMode']
-        tocMode = pageinfo['tocMode']
-        tocPN = pageinfo['tocPN']    
-        pagexml=self.template.fulltextclient.eval("/mpdl/interface/doc-query.xql", "document=%s&queryType=%s&queryResultPageSize=%s&queryResultPN=%s"%(docpath,queryType, pagesize, pn), outputUnicode=False)
-        page = pagexml.replace('page-fragment.xql?document=%s'%str(path),'%s?url=%s&viewMode=%s&tocMode=%s&tocPN=%s'%(selfurl,url, viewMode, tocMode, tocPN))
-        text = page.replace('mode=image','mode=texttool')
-        return text
     
 def changeDocumentViewer(self,title="",digilibBaseUrl=None,thumbrows=2,thumbcols=5,authgroups='mpiwg',RESPONSE=None):
Index: version.txt
===================================================================
--- version.txt	(revision 85)
+++ version.txt	(revision 130)
@@ -1,1 +1,1 @@
-DocumentViewer 0.3.0
+DocumentViewer 0.5.1