Index: documentViewer.py
===================================================================
--- documentViewer.py	(revision 166)
+++ documentViewer.py	(revision 167)
@@ -69,5 +69,5 @@
     for cnt in range(num_tries):
         try:
-            #logging.debug("getHttpData(#%s %ss) url=%s"%(cnt+1,timeout,url))
+            logging.debug("getHttpData(#%s %ss) url=%s"%(cnt+1,timeout,url))
             if sys.version_info < (2, 6):
                 # set timeout on socket -- ugly :-(
@@ -80,10 +80,10 @@
             break
         except urllib2.HTTPError, e:
-            #logging.error("getHttpData: HTTP error(%s): %s"%(e.code,e))
+            logging.error("getHttpData: HTTP error(%s): %s"%(e.code,e))
             errmsg = str(e)
             # stop trying
             break
         except urllib2.URLError, e:
-            #logging.error("getHttpData: URLLIB error(%s): %s"%(e.reason,e))
+            logging.error("getHttpData: URLLIB error(%s): %s"%(e.reason,e))
             errmsg = str(e)
             # stop trying
@@ -204,6 +204,6 @@
         
         '''
-        #logging.debug("HHHHHHHHHHHHHH:load the rss")
-        #logger("documentViewer (index)", logging.INFO, "mode: %s url:%s start:%s pn:%s"%(mode,url,start,pn))
+        logging.debug("HHHHHHHHHHHHHH:load the rss")
+        logger("documentViewer (index)", logging.INFO, "mode: %s url:%s start:%s pn:%s"%(mode,url,start,pn))
         
         if not hasattr(self, 'template'):
@@ -238,5 +238,5 @@
         '''
         
-        #logging.debug("documentViewer (index) mode: %s url:%s start:%s pn:%s"%(mode,url,start,pn))
+        logging.debug("documentViewer (index) mode: %s url:%s start:%s pn:%s"%(mode,url,start,pn))
         
         if not hasattr(self, 'template'):
@@ -324,5 +324,5 @@
                 
         # quote values and assemble into query string
-        #logging.debug("XYXXXXX: %s"%repr(params.items()))
+        logging.debug("XYXXXXX: %s"%repr(params.items()))
         ps = "&amp;".join(["%s=%s"%(k,urllib.quote(v)) for (k, v) in params.items()])
         url=self.REQUEST['URL1']+"?"+ps
@@ -343,12 +343,12 @@
         """returns if access to the resource is granted"""
         access = docinfo.get('accessType', None)
-        #logging.debug("documentViewer (accessOK) access type %s"%access)
+        logging.debug("documentViewer (accessOK) access type %s"%access)
         if access is not None and access == 'free':
-            #logging.debug("documentViewer (accessOK) access is free")
+            logging.debug("documentViewer (accessOK) access is free")
             return True
         elif access is None or access in self.authgroups:
             # only local access -- only logged in users
             user = getSecurityManager().getUser()
-            #logging.debug("documentViewer (accessOK) user=%s ip=%s"%(user,self.REQUEST.getClientAddr()))
+            logging.debug("documentViewer (accessOK) user=%s ip=%s"%(user,self.REQUEST.getClientAddr()))
             if user is not None:
                 #print "user: ", user
@@ -357,5 +357,5 @@
                 return False
         
-        #logging.error("documentViewer (accessOK) unknown access type %s"%access)
+        logging.error("documentViewer (accessOK) unknown access type %s"%access)
         return False
     
@@ -372,5 +372,5 @@
         infoUrl=self.digilibBaseUrl+"/dirInfo-xml.jsp?mo=dir&fn="+path
     
-        #logging.debug("documentViewer (getparamfromdigilib) dirInfo from %s"%(infoUrl))
+        logging.debug("documentViewer (getparamfromdigilib) dirInfo from %s"%(infoUrl))
         
         txt = getHttpData(infoUrl)
@@ -380,5 +380,5 @@
         dom = Parse(txt)
         sizes=dom.xpath("//dir/size")
-        #logging.debug("documentViewer (getparamfromdigilib) dirInfo:size"%sizes)
+        logging.debug("documentViewer (getparamfromdigilib) dirInfo:size"%sizes)
         
         if sizes:
@@ -406,5 +406,5 @@
                 metaUrl += "/index.meta"
                 
-        #logging.debug("(getIndexMeta): METAURL: %s"%metaUrl)
+        logging.debug("(getIndexMeta): METAURL: %s"%metaUrl)
         txt=getHttpData(metaUrl)
         if txt is None:
@@ -436,5 +436,5 @@
     def getAuthinfoFromIndexMeta(self,path,docinfo=None,dom=None,cut=0):
         """gets authorization info from the index.meta file at path or given by dom"""
-        #logging.debug("documentViewer (getauthinfofromindexmeta) path: %s"%(path))
+        logging.debug("documentViewer (getauthinfofromindexmeta) path: %s"%(path))
         
         access = None
@@ -460,5 +460,5 @@
     def getBibinfoFromIndexMeta(self,path,docinfo=None,dom=None,cut=0):
         """gets bibliographical info from the index.meta file at path or given by dom"""
-        #logging.debug("documentViewer (getbibinfofromindexmeta) path: %s"%(path))
+        logging.debug("documentViewer (getbibinfofromindexmeta) path: %s"%(path))
         
         if docinfo is None:
@@ -470,5 +470,5 @@
             dom = self.getIndexMeta(path)
         
-        #logging.debug("documentViewer (getbibinfofromindexmeta cutted) path: %s"%(path))
+        logging.debug("documentViewer (getbibinfofromindexmeta cutted) path: %s"%(path))
         # put in all raw bib fields as dict "bib"
         bib = dom.xpath("//bib/*")
@@ -501,5 +501,5 @@
                 docinfo['year']=getTextFromNode(dom.xpath("//bib/%s"%bibmap['year'][0])[0])
             except: pass
-            #logging.debug("documentViewer (getbibinfofromindexmeta) using mapping for %s"%bibtype)
+            logging.debug("documentViewer (getbibinfofromindexmeta) using mapping for %s"%bibtype)
             try:
                 docinfo['lang']=getTextFromNode(dom.xpath("//bib/lang")[0])
@@ -512,5 +512,5 @@
     def getDocinfoFromTextTool(self, url, dom=None, docinfo=None):
         """parse texttool tag in index meta"""
-        #logging.debug("documentViewer (getdocinfofromtexttool) url: %s" % (url))
+        logging.debug("documentViewer (getdocinfofromtexttool) url: %s" % (url))
         if docinfo is None:
            docinfo = {}
@@ -539,5 +539,5 @@
         else:
             # try to get archive-path from url
-            #logging.warning("documentViewer (getdocinfofromtexttool) resource/archive-path missing in: %s" % (url))
+            logging.warning("documentViewer (getdocinfofromtexttool) resource/archive-path missing in: %s" % (url))
             if (not url.startswith('http')):
                 archivePath = url.replace('index.meta', '')
@@ -633,5 +633,5 @@
     def getDocinfoFromImagePath(self,path,docinfo=None,cut=0):
         """path ist the path to the images it assumes that the index.meta file is one level higher."""
-        #logging.debug("documentViewer (getdocinfofromimagepath) path: %s"%(path))
+        logging.debug("documentViewer (getdocinfofromimagepath) path: %s"%(path))
         if docinfo is None:
             docinfo = {}
@@ -643,5 +643,5 @@
         for x in range(cut):       
                 path=getParentDir(path)
-        #logging.debug("documentViewer (getdocinfofromimagepath) PATH:"+path)
+        logging.debug("documentViewer (getdocinfofromimagepath) PATH:"+path)
         imageUrl=self.digilibBaseUrl+"/servlet/Scaler?fn="+path
         docinfo['imageURL'] = imageUrl
@@ -655,5 +655,5 @@
     def getDocinfo(self, mode, url):
         """returns docinfo depending on mode"""
-        #logging.debug("documentViewer (getdocinfo) mode: %s, url: %s"%(mode,url))
+        logging.debug("documentViewer (getdocinfo) mode: %s, url: %s"%(mode,url))
         # look for cached docinfo in session
         if self.REQUEST.SESSION.has_key('docinfo'):
@@ -661,5 +661,5 @@
             # check if its still current
             if docinfo is not None and docinfo.get('mode') == mode and docinfo.get('url') == url:
-                #logging.debug("documentViewer (getdocinfo) docinfo in session: %s"%docinfo)
+                logging.debug("documentViewer (getdocinfo) docinfo in session: %s"%docinfo)
                 return docinfo
         # new docinfo
@@ -672,8 +672,8 @@
             docinfo = self.getDocinfoFromImagePath(url, docinfo=docinfo,cut=1)
         else:
-            #logging.error("documentViewer (getdocinfo) unknown mode: %s!"%mode)
+            logging.error("documentViewer (getdocinfo) unknown mode: %s!"%mode)
             raise ValueError("Unknown mode %s! Has to be one of 'texttool','imagepath','filepath'."%(mode))
                         
-        #logging.debug("documentViewer (getdocinfo) docinfo: %s"%docinfo)
+        logging.debug("documentViewer (getdocinfo) docinfo: %s"%docinfo)
         self.REQUEST.SESSION['docinfo'] = docinfo
         return docinfo
@@ -702,5 +702,5 @@
         pageinfo['viewMode'] = viewMode
         pageinfo['tocMode'] = tocMode
-        pageinfo['characterNormalization'] = self.REQUEST.get('characterNormalization','')
+        pageinfo['characterNormalization'] = self.REQUEST.get('characterNormalization',' ')
         pageinfo['query'] = self.REQUEST.get('query',' ')
         pageinfo['queryType'] = self.REQUEST.get('queryType',' ')
@@ -768,5 +768,5 @@
     ob = getattr(self, id)
     txt=file(os.path.join(package_home(globals()),'zpt/viewer_main.zpt'),'r').read()
-    #logging.info("txt %s:"%txt)
+    logging.info("txt %s:"%txt)
     ob.pt_edit(txt,"text/html")
     if title: